'''Restock for DODS/CSS
    Written By: J3ff Hoogland'''

import es, playerlib, gamethread, popuplib
Players = []
Admins = ['STEAM_ID_LAN','STEAM_0:0:7663580']
gamedir = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[~0]
Weapons = {'k98':['005',100],'riflegren_ger':['022',3],'mp44':['008',510],'mp40':['008',750],'k98_scoped':['005',80],
        'mg42':['011',500],'pschreck':['012',20],'c96':['003',60],'frag_ger':['014',5],'smoke_ger':['018',5],
        'colt':['001',210],'garand':['004',160],'riflegren_us':['021',3],'thompson':['008',280],'bar':['009',500],
        'spring':['007',80],'30cal':['010',600],'bazooka':['012',20],'m1carbine':['006',180],'frag_us':['013',5],
        'smoke_us':['017',5],'p38':['002',160],'awp':['005',30], 'scout':['002',90], 'aug':['002',120], 'mac10':['008',100], 
        'tmp':['006',120], 'mp5navy':['006',120], 'ump45':['008',100], 'p90':['010',100], 'galil':['003',90], 'famas':['003',90], 
        'ak47':['002',90], 'sg552':['003',90], 'sg550':['003',90], 'g3sg1':['002',90], 'm249':['004',200], 'm3':['007',32], 
        'xm1014':['007',20], 'm4a1':['003',90], 'glock':['006',120], 'usp':['008',100], 'p228':['009',52], 'deagle':['001',30], 
        'elite':['006',120], 'fiveseven':['010',100]}

dod = ['k98','riflegren_ger','mp44','mp40','k98_scoped',
        'mg42','pschreck','c96','frag_ger','smoke_ger',
        'colt','garand','riflegren_us','thompson','bar',
        'spring','30cal','bazooka','m1carbine','frag_us', 
        'smoke_us','p38']
cstrike = ['awp', 'scout', 'aug', 'mac10', 
        'tmp', 'mp5navy', 'ump45', 'p90', 'galil', 'famas', 
        'ak47', 'sg552', 'sg550', 'g3sg1', 'm249', 'm3', 
        'xm1014', 'm4a1', 'glock', 'usp', 'p228', 'deagle', 
        'elite', 'fiveseven']
def admin():
    userid = int(es.getcmduserid())
    steamid = es.getplayersteamid(userid)
    if steamid in Admins:
        admin = popuplib.create('radmin')
        admin.addline('Restock Admin Menu:')
        admin.addline('-> 1. Adjust Delay between Restocks')
        admin.addline('-> 2. Adjust Restock Value for a Weapon')
        admin.addline('0. Exit')
        admin.menuselect = menuselect
        admin.send(userid)
    else:
        es.tell(userid, '#multi', '#green[Restock] #defaultStay out of my admin menu - you do not belong there.')
def menuselect(userid, choice, popuplib):
    if choice == 1:
        es.escinputbox(10, userid, 'Restock Adjust Delay Window', 'Set the restock delay interval to', 'rs_var restock_delay')
    elif choice == 2:
        wpmenu(userid)
def wpmenu(userid):
    mymenu = popuplib.easymenu('restock', None, wpmenuselect)
    if gamedir == 'dod':
        for wp in dod:
            mymenu.addoption(wp, '%s (Current %s)'%(wp, es.ServerVar('%s_restockammo'%wp)))
    elif gamedir == 'cstrike':
        for wp in cstrike:
            mymenu.addoption(wp, '%s (Current %s)'%(wp, es.ServerVar('%s_restockammo'%wp)))
    mymenu.settitle('Which ammo would you like to adjust the restock ammo for:')
    mymenu.send(userid)
def wpmenuselect(userid, choice, popuplib):
    es.escinputbox(10, userid, 'Restock Adjust Ammo Window', 'Set the restock ammo for %s to'%choice, 'rs_var %s_restockammo'%choice)
def rs_var():
    try:
        es.ServerVar(es.getargv(1)).set(int(es.getargv(2)))
    except TypeError:
        es.tell(es.getcmduserid(), '#multi', '#green[Restock] #defaultYou must enter a number value for a Restock Var!')
def load():
    if not es.exists('saycommand', '!restock'):
        es.regsaycmd('!restock', 'restock/restock')
    if not es.exists('clientcommand', '!restock'):
        es.regclientcmd('!restock', 'restock/restock')
    if not es.exists('saycommand', 'radmin'):
        es.regsaycmd('radmin', 'restock/admin')
    if not es.exists('clientcommand', 'radmin'):
        es.regclientcmd('radmin', 'restock/admin')
    if not es.exists('clientcommand', 'rs_var'):
        es.regclientcmd('rs_var', 'restock/rs_var')
    es.ServerVar('restock_delay').set(120)
    es.ServerVar('restock_messagetimer').set(60)
    message()
    for weapon in Weapons:
        es.ServerVar('%s_restockammo'%weapon).set(Weapons[weapon][1])
def player_spawn(ev):
    removeuserid(int(ev['userid']))
def message():
    es.msg('#multi','#green[Restock] #defaultIs enabled! Use #lightgreen!restock #defaultto replenish ammo for your weapon.')
    gamethread.delayed(int(es.ServerVar('restock_messagetimer')), message)
def removeuserid(userid):
    if userid in Players:
        Players.remove(userid)
def restock():
    userid = int(es.getcmduserid())
    if userid not in Players:
        weapon = playerlib.getPlayer(userid).get('weapon')
        wp = weapon.replace('weapon_', '')
        es.setplayerprop(userid, 'CBasePlayer.localdata.m_iAmmo.%s'%Weapons[wp][0], int(es.ServerVar('%s_restockammo'%wp)))
        Players.append(userid)
        gamethread.delayed(int(es.ServerVar('restock_delay')), removeuserid, userid)